Index: org/postgresql/util/PSQLState.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/util/PSQLState.java,v
retrieving revision 1.14
diff -u -r1.14 PSQLState.java
--- org/postgresql/util/PSQLState.java	31 Mar 2011 03:06:39 -0000	1.14
+++ org/postgresql/util/PSQLState.java	4 Jul 2011 21:38:33 -0000
@@ -88,6 +88,7 @@
 
     public final static PSQLState SYNTAX_ERROR = new PSQLState("42601");
     public final static PSQLState UNDEFINED_COLUMN = new PSQLState("42703");
+    public final static PSQLState UNDEFINED_OBJECT = new PSQLState("42704");
     public final static PSQLState WRONG_OBJECT_TYPE = new PSQLState("42809");
     public final static PSQLState NUMERIC_CONSTANT_OUT_OF_RANGE = new PSQLState("42820");
     public final static PSQLState DATA_TYPE_MISMATCH = new PSQLState("42821");
Index: org/postgresql/xa/PGXAConnection.java
===================================================================
RCS file: /cvsroot/jdbc/pgjdbc/org/postgresql/xa/PGXAConnection.java,v
retrieving revision 1.17
diff -u -r1.17 PGXAConnection.java
--- org/postgresql/xa/PGXAConnection.java	31 Mar 2011 06:25:42 -0000	1.17
+++ org/postgresql/xa/PGXAConnection.java	4 Jul 2011 21:38:34 -0000
@@ -407,7 +407,8 @@
         }
         catch (SQLException ex)
         {
-            throw new PGXAException(GT.tr("Error rolling back prepared transaction"), ex, XAException.XAER_RMERR);
+	    if (!ex.getSQLState().equals(PSQLState.UNDEFINED_OBJECT))
+		throw new PGXAException(GT.tr("Error rolling back prepared transaction"), ex, XAException.XAER_RMERR);
         }
     }
 
